/****************************************************************************
**
** SPDX-License-Identifier: BSD-2-Clause-Patent
**
** SPDX-FileCopyrightText: Copyright (c) 2022 SoftAtHome
**
** Redistribution and use in source and binary forms, with or
** without modification, are permitted provided that the following
** conditions are met:
**
** 1. Redistributions of source code must retain the above copyright
** notice, this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above
** copyright notice, this list of conditions and the following
** disclaimer in the documentation and/or other materials provided
** with the distribution.
**
** Subject to the terms and conditions of this license, each
** copyright holder and contributor hereby grants to those receiving
** rights under this license a perpetual, worldwide, non-exclusive,
** no-charge, royalty-free, irrevocable (except for failure to
** satisfy the conditions of this license) patent license to make,
** have made, use, offer to sell, sell, import, and otherwise
** transfer this software, where such license applies only to those
** patent claims, already acquired or hereafter acquired, licensable
** by such copyright holder or contributor that are necessarily
** infringed by:
**
** (a) their Contribution(s) (the licensed copyrights of copyright
** holders and non-copyrightable additions of contributors, in
** source or binary form) alone; or
**
** (b) combination of their Contribution(s) with the work of
** authorship to which such Contribution(s) was added by such
** copyright holder or contributor, if, at the time the Contribution
** is added, such addition causes such combination to be necessarily
** infringed. The patent license shall not apply to any other
** combinations which include the Contribution.
**
** Except as expressly stated above, no rights or licenses from any
** copyright holder or contributor is granted under this license,
** whether expressly, by implication, estoppel or otherwise.
**
** DISCLAIMER
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
** CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
** INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
** CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
** USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
** AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
** LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
** ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <setjmp.h>
#include <stdarg.h>
#include <cmocka.h>

#include <amxc/amxc.h>
#include <amxc/amxc_macros.h>
#include <amxp/amxp.h>
#include <amxd/amxd_dm.h>
#include <amxd/amxd_object.h>
#include <amxo/amxo.h>

#include <arpa/inet.h>
#include <linux/rtnetlink.h>

#include "netdev_netlink.h"

#include "test_netdev_nl_msg.h"

int test_netdev_setup(UNUSED void** state) {
    return 0;
}

int test_netdev_teardown(UNUSED void** state) {
    return 0;
}

void test_rtnlmsg_initialize(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();

    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    assert_int_equal(msg->buflen, 8192);
    assert_int_equal(msg->hdrlen, sizeof(struct ifaddrmsg));
    assert_true(msg->hdrlen < msg->nlmsg->nlmsg_len);
    assert_int_equal(msg->nlmsg->nlmsg_len, NLMSG_LENGTH(sizeof(struct ifaddrmsg)));
    assert_int_equal(msg->nlmsg->nlmsg_type, RTM_GETADDR);
    assert_int_equal(msg->nlmsg->nlmsg_flags, NLM_F_REQUEST);

    msg->nlmsg = NULL;
    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    rtnlmsg_initialize(NULL, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
}

void test_rtnlmsg_type(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();

    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    assert_int_equal(rtnlmsg_type(msg), RTM_GETADDR);
    msg->nlmsg = NULL;
    assert_int_equal(rtnlmsg_type(msg), 0);
    assert_int_equal(rtnlmsg_type(NULL), 0);

}

void test_rtnlmsg_buflen(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();

    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    assert_int_equal(rtnlmsg_buflen(msg), 8192);
    msg->nlmsg = NULL;
    assert_int_equal(rtnlmsg_buflen(msg), 8192);
    assert_int_equal(rtnlmsg_buflen(NULL), 0);
}

void test_rtnlmsg_nlhdr(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();
    struct nlmsghdr* hdr = NULL;
    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    hdr = rtnlmsg_nlhdr(msg);
    assert_true(hdr->nlmsg_len > sizeof(struct ifaddrmsg));
    assert_int_equal(hdr->nlmsg_len, NLMSG_LENGTH(sizeof(struct ifaddrmsg)));
    assert_int_equal(hdr->nlmsg_type, RTM_GETADDR);
    assert_int_equal(hdr->nlmsg_flags, NLM_F_REQUEST);

    msg->nlmsg = NULL;
    assert_null(rtnlmsg_nlhdr(msg));
    assert_null(rtnlmsg_nlhdr(NULL));
}

void test_rtnlmsg_hdr(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();
    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    assert_int_equal(rtnlmsg_hdr(msg), NLMSG_DATA(msg->nlmsg));
    msg->nlmsg = NULL;
    assert_int_equal(rtnlmsg_hdr(msg), 0);
    assert_null(rtnlmsg_hdr(NULL));
}

void test_rtnlmsg_attr(UNUSED void** state) {
    const char* name = NULL;
    struct rtattr* rv = NULL;
    rtnlmsg_t* msg = rtnlmsg_instance();

    msg->nlmsg = (struct nlmsghdr*) "\x4c\x05\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x11\x00\x00\x00\x82\x00\x00\x00\xff\xff\xff\xff\x0b\x00\x03\x00\x64\x75\x6d\x6d\x79\x30\x00\x00\x08\x00\x0d\x00\xe8\x03\x00\x00\x05\x00\x10\x00\x02\x00\x00\x00\x05\x00\x11\x00\x00\x00\x00\x00\x08\x00\x04\x00\xdc\x05\x00\x00\x08\x00\x32\x00\x00\x00\x00\x00\x08\x00\x33\x00\x00\x00\x00\x00\x08\x00\x1b\x00\x00\x00\x00\x00\x08\x00\x1e\x00\x00\x00\x00\x00\x08\x00\x1f\x00\x01\x00\x00\x00\x08\x00\x28\x00\xff\xff\x00\x00\x08\x00\x29\x00\x00\x00\x01\x00\x08\x00\x20\x00\x01\x00\x00\x00\x05\x00\x21\x00\x01\x00\x00\x00\x09\x00\x06\x00\x6e\x6f\x6f\x70\x00\x00\x00\x00\x08\x00\x23\x00\x00\x00\x00\x00\x08\x00\x2f\x00\x00\x00\x00\x00\x08\x00\x30\x00\x00\x00\x00\x00\x05\x00\x27\x00\x00\x00\x00\x00\x24\x00\x0e\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0a\x00\x01\x00\x4a\x33\x20\xe4\xe9\x18\x00\x00\x0a\x00\x02\x00\xff\xff\xff\xff\xff\xff\x00\x00\xc4\x00\x17\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x64\x00\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0c\x00\x2b\x00\x05\x00\x02\x00\x00\x00\x00\x00\x10\x00\x12\x00\x0a\x00\x01\x00\x64\x75\x6d\x6d\x79\x00\x00\x00\x0c\x03\x1a\x00\x88\x00\x02\x00\x84\x00\x01\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x02\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x10\x27\x00\x00\xe8\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x02\x0a\x00\x08\x00\x01\x00\x00\x00\x00\x00\x14\x00\x05\x00\xff\xff\x00\x00\xad\x76\xa4\x00\xf0\x95\x00\x00\xe8\x03\x00\x00\xe4\x00\x02\x00\x00\x00\x00\x00\x40\x00\x00\x00\xdc\x05\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\xff\xff\xff\xff\xa0\x0f\x00\x00\xe8\x03\x00\x00\x00\x00\x00\x00\x80\x3a\x09\x00\x80\x51\x01\x00\x03\x00\x00\x00\x58\x02\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x01\x00\x00\x00\x60\xea\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\xff\xff\xff\xff\x00\x00\x00\x00\x00\x00\x00\x00\x10\x27\x00\x00\xe8\x03\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\xee\x36\x00\x00\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x04\x00\x00\x00\x00\x00\x00\xff\xff\x00\x00\xff\xff\xff\xff\x2c\x01\x03\x00\x25\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x34\x00\x06\x00\x06\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x14\x00\x07\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x05\x00\x08\x00\x00\x00\x00\x00";
    msg->buflen = 8192;
    msg->hdrlen = 16;

    rv = rtnlmsg_attr(msg, IFLA_IFNAME);
    assert_non_null(rv);
    name = (const char*) RTA_DATA(rtnlmsg_attr(msg, IFLA_IFNAME));
    assert_non_null(name);
    assert_string_equal(name, "dummy0");

    assert_null(rtnlmsg_attr(msg, RTM_GETADDR));
    msg->nlmsg = NULL;
    assert_null(rtnlmsg_attr(NULL, RTM_GETADDR));

}

void test_rtnlmsg_attrFirst(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();

    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    assert_int_equal(rtnlmsg_attrFirst(msg), (NLMSG_DATA(msg->nlmsg) + NLMSG_ALIGN(msg->hdrlen)));
    msg->nlmsg = NULL;
    assert_null(rtnlmsg_attrFirst(msg));
    assert_null(rtnlmsg_attrFirst(NULL));
}

void test_rtnlmsg_attrLen(UNUSED void** state) {
    rtnlmsg_t* msg = rtnlmsg_instance();

    rtnlmsg_initialize(msg, RTM_GETADDR, sizeof(struct ifaddrmsg), NLM_F_REQUEST);
    assert_int_equal(rtnlmsg_attrLen(msg), NLMSG_PAYLOAD(msg->nlmsg, msg->hdrlen));
    msg->nlmsg = NULL;
    assert_int_equal(rtnlmsg_attrLen(msg), 0);
    assert_int_equal(rtnlmsg_attrLen(NULL), 0);
}
